/*
 * Simple doubly linked list ADT test
 */
public class DLinkListTest
{
  public static void main(String[] args)
  {
    test();
  }
  public static void main()
  {
    test();
    while(true); // end of embedded system code
  }

  public static void test()
  {
    System.out.println(" ");
    System.out.println("Starting DLinkedListTest");

    DLlist list = new DLlist();
    
    list.insert("Eric Clapton");
    list.insert("Ted Nugent");
    list.insert("Jimmy Page");
    list.insert("Angus Young");
    list.show();

    list.delete("Jimmy Page");
    list.delete("Ted Nugent");
    list.show();

    DLnode node = list.find("Angus Young");
    if(node != null)
      System.out.println("Found and deleting: " + (String)node.getObject()); 
    list.delete(node);
    list.show();

    list.delete("Eric Clapton");
    list.show();

    list.add("Pete Carr");
    list.add("Play that guitar!");
    list.show();


    list.insert("WelcomeGuest");
    list.insert("If");
    list.insert("this");
    list.insert("is");
    list.insert("your");
    list.insert("first");
    list.insert("visit");
    list.insert("to");
    list.insert("the");
    list.insert("Parallax");
    list.insert("Forums");
    list.insert("you");
    list.insert("will");
    list.insert("need");
    list.insert("to");
    list.insert("register");
    list.insert("before");
    list.insert("you");
    list.insert("will");
    list.insert("be");
    list.insert("allowed");
    list.insert("to");
    list.insert("post");
    list.insert("on");
    list.insert("the");
    list.insert("forum,");
    list.insert("but");
    list.insert("you");
    list.insert("are");
    list.insert("free");
    list.insert("to");
    list.insert("browse");
    list.insert("the");
    list.insert("forums");
    list.insert("by");
    list.insert("selecting");
    list.insert("from");
    list.insert("the");
    list.insert("listing");
    list.insert("below.");
    list.insert("To");
    list.insert("help");
    list.insert("you");
    list.insert("find");
    list.insert("your");
    list.insert("way");
    list.insert("around");
    list.insert("the");
    list.insert("forum");
    list.insert("and");
    list.insert("its");
    list.insert("features,");
    list.insert("please");
    list.insert("view");
    list.insert("the");
    list.insert("help");
    list.insert("If");
    list.insert("you");
    list.insert("have");
    list.insert("registered");
    list.insert("but");
    list.insert("have");
    list.insert("not");
    list.insert("received");
    list.insert("a");
    list.insert("confirmation");
    list.insert("email,");
    list.insert("please");
    list.insert("contact");
    list.insert("forumadmin@parallax.com");
    list.insert("for");
    list.insert("assistance.");
    list.show();

    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("documentation.");
    list.delete("from");
    list.delete("but");
    list.delete("you");
    list.delete("are");
    list.delete("free");
    list.delete("to");
    list.delete("browse");
    list.delete("the");
    list.show();

    list.insert("WelcomeGuest");
    list.insert("WelcomeGuest");
    list.insert("WelcomeGuest");
    list.insert("WelcomeGuest");
    list.insert("WelcomeGuest");
    list.insert("WelcomeGuest");
    list.insert("WelcomeGuest");
    list.insert("WelcomeGuest");

    System.out.println(" ");
    System.out.println("Test Complete.");
  }

}
