import stamp.core.PROP;
import stamp.core.Timer;
import stamp.core.Uart;



public class JMSerialLCDTest 
{	
    //static boolean tick=true;
    
    /*
    
    private static int fibo(int n)
    {
      if ( n > 2 ) {
        return fibo(n-1) + fibo(n-2);
      }
      else {
        return 1;
      }
    }

    public static void fibo(int count, int end, ScaledTimer16 scaledTimer)
    {
      int result = 0;
      int ms = 0;
      int passed = 0;

      while(count <= end) {

        Format.printf("FIBO(%02d)", count);
        scaledTimer.mark();
        result = fibo(count);
        //CPU.delay(1000); // delay 95.48ms according to Javelin definition
        passed = scaledTimer.passedTicks();
        ms = scaledTimer.TicksToTime(passed);

        Format.printf(" = %5u ", result);
        Format.printf("(%5u ms)\r\n", ms);

        count++;
      }

    }
    */
    
	public static void main ()
	{				
		System.out.println ("JMSerialLCDTest.java v2.3");
		
        Uart rx = new Uart(Uart.dirReceive, PROP.pin31, Uart.invert, Uart.speed19200, Uart.stop1);
        
        
        Timer timer = new Timer ();
        
        System.out.println ("Loop 1");
        timer.mark();
        while (!timer.timeoutSec(10))
        {
			if (rx.byteAvailable())
			{
				System.out.print((char)rx.readByte());
			}
        }
        
        


        System.out.println("Starting Loopback Test");
        System.out.println("Type in terminal for echo.");


		System.out.println ("Waiting 2 second...");
		PROP.delay(20);
		System.out.println ("... Done");
		
		
		
		/*
		System.out.println ("\nStarting LCD test...");
		System.out.println ("Starting UART");
		Uart screenUart = new Uart(Uart.dirTransmit, PROP.pin27, Uart.invert, Uart.speed19200, Uart.stop1);
		System.out.println ("Sending content");
		screenUart.writeString("12345678901234567890");
		System.out.println ("Stopping UART");
		screenUart.stop();
		System.out.println ("End...");
		*/
		

		
		System.out.println ("Waiting 2 second...");
		PROP.delay(20);
		System.out.println ("... Done");


		/*
		ScaledTimer16 scaledTimer = new ScaledTimer16 (400, 100);
		Timer clock = new Timer();
		System.out.println ("\nStarting DS1302 test...");		
		DS1302 ds1302 = new DS1302 (PROP.pin23, PROP.pin31, PROP.pin30);
		for (int i = 0; i < 10; i++)
        {
			System.out.print (ds1302.readTime(false));
            int time = scaledTimer.passedTime();
            scaledTimer.mark();
            System.out.print(" ");
            System.out.print(time);
            System.out.println(" ms. ");
            for (clock.mark(); !clock.timeout(932);) ; // wait for one second
        } // end for
		System.out.println ("End...");
		*/
		
		/* 						
		System.out.println ("\nStarting ScaledTimer test...");										
		for (int i = 0; i < 60; i++)
        {
            scaledTimer.mark();
            for (clock.mark(); !clock.timeout(1000););
            int ticks = scaledTimer.passedTicks();
            int time = scaledTimer.passedTime();
            
            System.out.print(i);
            System.out.print(" ");
            System.out.print(ticks);
            System.out.print(" ticks. ");
            System.out.print(time);
            System.out.print(" ms. ");
            System.out.println(tick?"tick":"tock");
            tick=!tick;
        } // end for
		System.out.println ("End...");
		
		System.out.println ("\nStarting Fibo test...");
		JMSerialLCDTest.fibo(0,24,scaledTimer);
		System.out.println ("End...");
		*/
		System.out.println ("\nStarting MultiSegmentDisplayDriver test...");		
		for (int i = 0; i < PROP.pins.length - 1; i++)
		{
			PROP.setOutput(PROP.pins[i]);
			PROP.writePin(PROP.pins[i], false);
		}		
		PROP.setInput(PROP.pin23);
		PROP.setInput(PROP.pin24);
		PROP.setInput(PROP.pin25);
		PROP.setInput(PROP.pin26);

        System.out.println ("Loop 2");
        timer.mark();
        while (!timer.timeoutSec(10))
        {
			if (rx.byteAvailable())
			{
				System.out.print((char)rx.readByte());
			}
        }
        				
		/*
		MultiSegmentDisplayDriver msdd = new MultiSegmentDisplayDriver ();
	    byte val = 91;

        System.out.println ("Loop 3");
        timer.mark();
        while (!timer.timeoutSec(10))
        {
			if (rx.byteAvailable())
			{
				System.out.print((char)rx.readByte());
			}
        }
	    
	    
		for (byte i = 0; i < msdd.nbDigits; i++)
		{
			msdd.assignChar(val++, i);			
		}
		
		while (true)
		{
			boolean dataReceived = rx.byteAvailable();
			msdd.draw();			
			if (dataReceived)
			{
				System.out.print((char)rx.readByte());
	    		for (byte i = 0; i < msdd.nbDigits; i++)
	    		{
	    			msdd.assignChar(val, i);
	    			val = (byte)((val + 1) % 127);
	    		}	    		    		
			}
			msdd.draw();
		}
		*/
		
		
		while (true);

	}
}

