import stamp.core.*;

public class ListTest {
    static ListTest head=null; // pointer to first item
    String value;
    ListTest next;
    // create list element (not linked)
    ListTest(String s) {
        value=s;
        next=null;
    } // end ListTest
    // insert item in list
    void insert() {
        ListTest ptr, last;
        if (head==null) {
            head=this;
            return;
        } // end if
        // this code finds the last item in list
        last=head;
        for (ptr=head;ptr!=null;ptr=ptr.next)
        last=ptr;
        last.next=this;
    } // end insert
    static void printList() {
        ListTest ptr;
        for (ptr=head;ptr!=null;ptr=ptr.next)
        System.out.println(ptr.value);
    } // end printList
    static public void main() {
        new ListTest("One").insert();
        new ListTest("Two").insert();
        new ListTest("Three").insert();
        new ListTest("Four").insert();
        ListTest.printList();
    } // end main
} // end class declaration

