package stamp.util.os;

import java.io.* ;
import stamp.core.* ;


/**
 * Multitasking status support class
 * <p>
 * This is a class object only.
 *
 * @version 1.0 8/23/02
 * @author Parallax Inc.
 */

public class ShowStatus {
  static public PrintStream stream = System.out ;

  protected static void print ( Event event ) {
    stream.print ( "<") ;
    stream.print ( event.name ()) ;
    stream.print ( "> ") ;
  }

  protected static void print ( int value ) {
    stream.print ( value ) ;
  }

  protected static void print ( String string ) {
    stream.print ( string ) ;
  }

  protected static void println ( String string ) {
    stream.println ( string ) ;
  }

  protected static void println () {
    stream.println ( " " ) ;
  }
}