/*
 * @file DLnode.java
 * Defines a doubly linked list node
 *
 */
public class DLnode
{
  protected Object obj;
  protected DLnode next;
  protected DLnode prev;

  public DLnode(Object object)
  {
    obj   = object;
    next  = null;
    prev  = null;
  }
  public DLnode()
  {
    next  = null;
    prev  = null;
  }
  public Object getObject()
  {
    return obj;
  }
  public DLnode getNext()
  {
    return next;
  }
  public void setNext(DLnode node)
  {
    next = node;
  }
  public DLnode getPrev()
  {
    return prev;
  }
  public void setPrev(DLnode node)
  {
    prev = node;
  }

}
