import stamp.core.*;
import stamp.util.text.*;
import stamp.math.*;

public class IntegerMath_test {

  static int j;

  static void main() {
    j = IntegerMath.sin(45);
    Format.printf("sin(45) = %d\r\n",j); //j = 0.707*100 = 70
    j = IntegerMath.sin(135);
    Format.printf("sin(135) = %d\r\n",j); //j = 0.707*100 = 70
    j = IntegerMath.sin(225);
    Format.printf("sin(225) = %d\r\n",j); //j = -0.707*100 = -70
    j = IntegerMath.sin(315);
    Format.printf("sin(315) = %d\r\n",j); //j = -0.707*100 = -70

    j = IntegerMath.cos(45);
    Format.printf("cos(45) = %d\r\n",j); //j = 0.707*100 = 70
    j = IntegerMath.cos(135);
    Format.printf("cos(135) = %d\r\n",j); //j = -0.707*100 = -70
    j = IntegerMath.cos(225);
    Format.printf("cos(225) = %d\r\n",j); //j = -0.707*100 = -70
    j = IntegerMath.cos(315);
    Format.printf("cos(315) = %d\r\n",j); //j = 0.707*100 = 70

    j = IntegerMath.atan2(45,45);
    Format.printf("atan2(45,45) = %d\r\n",j); //j = 45
    j = IntegerMath.atan2(45,-45);
    Format.printf("atan2(45,-45) = %d\r\n",j); //j = 135
    j = IntegerMath.atan2(-45,-45);
    Format.printf("atan2(-45,-45) = %d\r\n",j); //j = 225
    j = IntegerMath.atan2(-45,45);
    Format.printf("atan2(-45,45) = %d\r\n",j); //j = 315

    Format.printf("Program completed\r\n");
    while (true) ;
  }

}
