
import stamp.core.CPU;
import stamp.peripheral.io.EE24LC256;
import stamp.peripheral.io.I2C;
import stamp.util.text.Format;



public class JM_I2CTest 
{    
    
    public static void main ()
    {                
        System.out.println ("SerialLCDTest.java v2.4");
        
        System.out.println ("\nStarting EE24LC256 test...");
        
        I2C ioBus = new I2C(CPU.pin29, CPU.pin28);
        EE24LC256 eeI2C = new EE24LC256(ioBus,0x00); 
      
        System.out.print("Step 1");
      
        if(!eeI2C.isPresent())
        {
            System.out.print("EEPROM Not Found.");
        }
        else
        {
            System.out.print("Step 2");
          
            //readTest(ioBus, 0,0);
    
            CPU.writePin(CPU.pin0,false);
          
            System.out.println("Step 3");
            boolean readloop = false;
            do 
            {
              for(int n = 3; n >= 0; n--) 
              {
                Format.printf("%02x", eeI2C.read(0x00,n));
              }
              System.out.print("\r\n");
            }
            while ( readloop );
        }
        
        while (true);
    }
}

